config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  resources :people
  resources :processes do
    resources :phases, only: [:new, :create]
  end

  root to: 'home#index'
end

app/models/app_filters/people.rb
class AppFilters::People
  def initialize(params)
    @params = params
  end

  def filter
    filter_by_type
    filter_by_search_term
    @people
  end

  private

  [:search, :type].each do |key|
    define_method key do
      @params[key]
    end
  end


  def filter_by_type
    case type
    when 'physical'
      @people = PhysicalPerson.all
    when 'legal'
      @people = LegalPerson.all
    else
      @people = PhysicalPerson.all
    end
  end

  def filter_by_search_term
    return unless search.present?
    search =~ /\d/ ? doc_search : name_search
  end

  def doc_search
    doc = search.gsub(/\D/, '')
    @people = @people.where('doc LIKE ?', "%#{doc}%")
  end

  def name_search
    field = type == 'physical' ? 'name' : 'trading_name'
    @people = @people.where("#{field} ILIKE ?", "%#{search}%")
  end
end

app/controllers/people_controller.rb
class PeopleController < ApplicationController
  before_action :set_person, only: [:show, :edit, :update]

  def new
    @person = type_person
  end

  def index
    collection
    respond_with @people
    @people
  end

  def show
  end

  def edit
  end

  def update
    @person.update type_person_params
    respond_with @person, location: -> { person_path(@person, type: @person.class.type) }
  end

  def create
    @person = type_person
    @person.update type_person_params

    respond_with @person, location: -> { person_path(@person, type: @person.class.type) }
  end

  private

  def collection
    @filters = filter_params
    @people = AppFilters::People.new(@filters).filter
    @people = @people.page(params[:page])
  end

  def type_person
    case params[:type]
    when 'physical' then return PhysicalPerson.new
    when 'legal' then  return LegalPerson.new
    end
    PhysicalPerson.new
  end

  def set_person
    case params[:type]
    when 'physical' then @person = PhysicalPerson.find(params[:id])
    when 'legal' then @person = LegalPerson.find(params[:id])
    end
  end

  def type_person_params
    case params[:type]
    when 'physical' then return physical_person_params
    when 'legal' then return legal_person_params
    else raise 'Can\'t Verify the type of person'
    end
  end

  def physical_person_params
    params.require(:physical_person)
          .permit(:name, :doc, :rdoc, :mothers_name,
                  :profession, :born_at, :marital_status,
                  addresses_attributes: [:id, :name, :number, :additional,
                                         :neighborhood, :city, :state,
                                         :_destroy],
                  phones_attributes: [:id, :number, :_destroy])
  end

  def legal_person_params
    params.require(:legal_person)
          .permit(:legal_name, :doc, :trading_name, :state_registration,
                  addresses_attributes: [:id, :name, :number, :additional,
                                         :neighborhood, :city, :state,
                                         :_destroy],
                  phones_attributes: [:id, :number, :_destroy])
  end

  def filter_params
    return { type: 'physical' } unless params[:filters].present?
    params.require(:filters).permit(:search, :type)
  end

  def flash_interpolation_options
    { resource_name: @person.name }
  end
end

app/views/people/show/_legal_person.html.haml
%h4= fa_icon :info, text: 'Informações'
%hr.legend

%dl.dl-horizontal
  = show_attr_info @person, :trading_name
  = show_attr_info @person, :doc, method: :doc_with_mask
  = show_attr_info @person, :state_registration

app/views/people/show/_physical_person.html.haml
%h4= fa_icon :info, text: 'Informações'
%hr.legend

%dl.dl-horizontal
  = show_attr_info @person, :doc, method: :doc_with_mask
  = show_attr_info @person, :rdoc
  = show_attr_info @person, :mothers_name
  = show_attr_info @person, :marital_status, method: :marital_status_i18n
  = show_attr_info @person, :profession
  = show_attr_info @person, :born_at, format: :long

app/views/people/show/_processes.html.haml
.row
  .col-xs-7
    %h4= model_with_icon McomProcess, :plural
  .col-xs-5.text-right.h4
    = button_to_add new_process_path(author: person.id_to_select), label: 'Novo processo'
%hr.legend

%table.table.table-striped
  %thead
    %tr
      %th
      %th= McomProcess.human_attribute_name(:description)
      %th= McomProcess.human_attribute_name(:start_date)
      %th= McomProcess.human_attribute_name(:author)
      %th= McomProcess.human_attribute_name(:defendant)
      %th
  %tbody
    - person.processes.each do |process|
      %tr
        %td
        %td= process.description
        %td= I18n.l process.start_date
        %td= process.author.name
        %td= process.defendant.name
        %td.text-right
          = button_to_show process_path(process), label: nil